import { jsx as g, jsxs as se } from "react/jsx-runtime";
import le, { useRef as f, useEffect as C, useCallback as ie, useMemo as j, useState as _, useId as ue, useReducer as de, useLayoutEffect as N } from "react";
import l from "clsx";
/*!
  @versini/ui-textarea v1.0.10
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TEXTAREA__ || (window.__VERSINI_UI_TEXTAREA__ = {
    version: "1.0.10",
    buildTime: "12/12/2024 05:56 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const z = "av-text-area", fe = "av-text-area-wrapper", H = "av-text-area-helper-text", pe = "av-text-area__control--right";
function me() {
  const e = f(!1);
  return C(() => (e.current = !0, () => {
    e.current = !1;
  }), []), ie(() => e.current, []);
}
function ye(e) {
  return j(() => e.every((r) => r == null) ? () => {
  } : (r) => {
    e.forEach((t) => {
      typeof t == "function" ? t(r) : t != null && (t.current = r);
    });
  }, e);
}
const he = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function xe(e) {
  const r = me(), t = f(0), n = f(null), [o, c] = _(he), a = j(() => typeof ResizeObserver > "u" ? null : new ResizeObserver((u) => {
    const s = u[0];
    s && (cancelAnimationFrame(t.current), t.current = requestAnimationFrame(() => {
      n.current && r() && c(s.contentRect);
    }));
  }), [r]);
  return C(() => (n.current && (a == null || a.observe(n.current, e)), () => {
    a == null || a.disconnect(), t.current && cancelAnimationFrame(t.current);
  }), [a, e]), [n, o];
}
function Ae({
  value: e,
  defaultValue: r,
  finalValue: t,
  onChange: n = () => {
  },
  initialControlledDelay: o = 0
}) {
  const [c, a] = _(!1), [u, s] = _(
    r !== void 0 ? r : t
  ), p = (m) => {
    s(m), n == null || n(m);
  };
  return C(() => {
    (async () => e !== void 0 && !c && o > 0 && (await new Promise(
      (m) => setTimeout(m, o)
    ), a(!0)))();
  }, [e, o, c]), e !== void 0 ? !c && o > 0 ? ["", n, !0] : [e, n, !0] : [u, p, !1];
}
function ge(e) {
  const r = ue();
  if (!e)
    return r;
  if (typeof e == "number" || typeof e == "string")
    return `${e}${r}`;
  if (typeof e == "object") {
    const { id: t, prefix: n = "" } = e;
    return typeof t == "number" || typeof t == "string" ? `${n}${t}` : `${n}${r}`;
  }
}
const G = "SET_ANNOUNCEMENT", W = "CLEAR_ANNOUNCEMENT", Te = {
  alert: null,
  alertdialog: null,
  log: "polite",
  marquee: null,
  progressbar: null,
  status: "polite",
  timer: "assertive"
}, be = (e, r) => {
  switch (r == null ? void 0 : r.type) {
    case G:
      return {
        ...e,
        announcement: r.payload
      };
    case W:
      return {
        ...e,
        announcement: null
      };
    default:
      return e;
  }
}, ve = ({
  onAnnouncementClear: e,
  dispatch: r
}) => {
  r({
    type: W
  }), typeof e == "function" && e();
}, X = ({
  children: e,
  clearAnnouncementDelay: r,
  clearAnnouncementTimeoutRef: t,
  onAnnouncementClear: n,
  dispatch: o
}) => {
  clearTimeout(t.current), e !== null && o({
    type: G,
    payload: e
  }), r && (t.current = setTimeout(
    () => ve({
      onAnnouncementClear: n,
      dispatch: o
    }),
    r
  ));
}, ke = ({
  children: e,
  announcementTimeoutRef: r,
  announcementDelay: t,
  clearAnnouncementDelay: n,
  clearAnnouncementTimeoutRef: o,
  onAnnouncementClear: c,
  dispatch: a
}) => {
  clearTimeout(r.current), t ? r.current = setTimeout(X, t, {
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: c,
    dispatch: a
  }) : X({
    children: e,
    clearAnnouncementDelay: n,
    clearAnnouncementTimeoutRef: o,
    onAnnouncementClear: c,
    dispatch: a
  });
};
function _e({
  children: e,
  className: r,
  politeness: t,
  role: n = null,
  announcementDelay: o,
  clearAnnouncementDelay: c,
  onAnnouncementClear: a,
  visible: u,
  ...s
}) {
  const p = f(null), m = f(null), [T, v] = de(be, {
    announcement: null
  });
  let x = t;
  typeof x > "u" && (x = n ? Te[n] : "assertive"), C(() => {
    ke({
      announcementTimeoutRef: p,
      announcementDelay: o,
      children: e,
      clearAnnouncementDelay: c,
      clearAnnouncementTimeoutRef: m,
      onAnnouncementClear: a,
      dispatch: v
    });
  }, [
    e,
    o,
    c,
    a
  ]);
  const d = l(r, {
    "sr-only": !u
  });
  return /* @__PURE__ */ g(
    "div",
    {
      "aria-live": x,
      ...n && { role: n },
      className: d,
      ...s,
      children: T.announcement
    }
  );
}
const Ee = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
};
/*!
  @versini/ui-private v1.4.19
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_PRIVATE__ || (window.__VERSINI_UI_PRIVATE__ = {
    version: "1.4.19",
    buildTime: "12/12/2024 05:56 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const Re = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", Ne = ({
  mode: e
}) => l({
  "bg-surface-darker text-copy-lighter caret-copy-light": e === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": e === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": e === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": e === "alt-system"
}), Ce = ({
  focusMode: e
}) => l("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": e === "dark",
  "focus:outline-focus-light": e === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": e === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": e === "system"
}), Ie = ({
  noBorder: e,
  error: r
}) => l("border-2", {
  "border-border-dark": !e && !r,
  "focus:border-border-dark": !e && r,
  "border-border-error-dark": !e && r,
  "border-transparent": e
}), Se = ({
  disabled: e,
  raw: r,
  error: t,
  mode: n
}) => {
  if (r)
    return "";
  if (e)
    return l("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!t)
    return l("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": n === "dark",
      "text-copy-dark": n === "light",
      "text-copy-dark dark:text-copy-medium": n === "system",
      "text-copy-medium dark:text-copy-dark": n === "alt-system"
    });
  if (t)
    return l("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": n === "dark",
      "text-copy-error-dark": n === "light",
      "text-copy-error-dark dark:text-copy-error-light": n === "system",
      "text-copy-medium dark:text-copy-error-dark": n === "alt-system"
    });
}, Oe = ({
  error: e,
  raw: r,
  mode: t,
  disabled: n
}) => {
  if (r)
    return "";
  if (n)
    return l(
      H,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!e)
    return l(H, "absolute px-2 font-medium", {
      "text-copy-medium": t === "dark",
      "text-copy-dark": t === "light",
      "text-copy-dark dark:text-copy-medium": t === "system",
      "text-copy-medium dark:text-copy-dark": t === "alt-system"
    });
  if (e)
    return l(H, "absolute px-2 font-medium", {
      "text-copy-error-light": t === "dark",
      "text-copy-error-dark": t === "light",
      "text-copy-error-dark dark:text-copy-error-light": t === "system",
      "dark:text-copy-error-dark text-copy-error-light": t === "alt-system"
    });
}, $e = ({
  className: e,
  textAreaClassName: r,
  raw: t,
  focusMode: n,
  disabled: o,
  noBorder: c,
  error: a,
  spacing: u,
  mode: s
}) => {
  const p = t ? e : l(
    "relative flex w-full flex-col justify-center",
    fe,
    e,
    Ee(u)
  ), m = t ? l(r) : l(
    z,
    r,
    Re(),
    Ne({ mode: s }),
    Ce({ focusMode: n }),
    Ie({
      noBorder: c,
      error: a
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": o
    }
  ), T = t ? void 0 : "sr-only", v = Se({
    disabled: o,
    raw: t,
    error: a,
    mode: s
  }), x = Oe({
    error: a,
    raw: t,
    mode: s,
    disabled: o
  }), d = t ? void 0 : l(pe, "absolute");
  return {
    wrapper: p,
    textArea: m,
    accessibleLabel: T,
    visibleLabel: v,
    helperText: x,
    rightElement: d
  };
}, Le = ({
  scrollHeight: e,
  currentHeight: r,
  currentLabelOffset: t = 0,
  currentHelperTextOffset: n = 0
}) => {
  let a, u;
  if (e > 0 && e !== r) {
    const s = e - r, p = Math.abs(s / 24);
    a = t + -1 * Math.sign(s) * (12 * p), u = n + Math.sign(s) * (12 * p);
  }
  return {
    labelOffset: a,
    helperTextOffset: u,
    scrollHeight: e
  };
}, we = le.forwardRef(
  ({
    id: e,
    name: r,
    label: t,
    error: n = !1,
    raw: o = !1,
    className: c,
    textAreaClassName: a,
    mode: u = "system",
    focusMode: s = "system",
    value: p,
    defaultValue: m,
    disabled: T = !1,
    noBorder: v = !1,
    labelId: x,
    helperText: d = "",
    helperTextOnFocus: I = !1,
    rightElement: S,
    onChange: P,
    onFocus: D,
    onBlur: M,
    spacing: q,
    ...B
  }, J) => {
    const y = f(null), K = ye([J, y]), [Q, E] = xe(), O = f(80), F = f(-25), A = f(null), U = f(30), R = f(null), k = ge({ id: e, prefix: `${z}-` }), [Y, Z] = _(0), [ee, V] = _(
      !!(!I && d)
    ), te = `${r} error, ${d}`, b = $e({
      className: c,
      textAreaClassName: a,
      error: n,
      raw: o,
      focusMode: s,
      disabled: T,
      noBorder: v,
      spacing: q,
      mode: u
    }), [h, re] = Ae({
      value: p,
      initialControlledDelay: 20,
      defaultValue: m,
      onChange: (i) => {
        P && P({
          target: {
            value: i
          }
        });
      }
    }), ne = (i) => {
      re(i.target.value);
    }, oe = (i) => {
      I && d && V(!0), D && D(i);
    }, ae = (i) => {
      I && d && !h && V(!1), M && M(i);
    };
    return N(() => {
      E && E.width && Z(E.width + 18 + 10);
    }, [E]), N(() => {
      o || y && y.current && h !== void 0 && (y.current.style.height = "inherit", y.current.style.height = y.current.scrollHeight + "px");
    }, [h, o]), N(() => {
      o || setTimeout(() => {
        var i;
        (i = A == null ? void 0 : A.current) == null || i.style.setProperty(
          "--av-text-area-wrapper-transition",
          h ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [h, o]), N(() => {
      var i, $;
      if (!o && y && y.current && h !== void 0) {
        const { labelOffset: L, helperTextOffset: w, scrollHeight: ce } = Le({
          scrollHeight: y.current.scrollHeight,
          currentHeight: O.current,
          currentLabelOffset: F.current,
          currentHelperTextOffset: U.current
        });
        L && (F.current = L, (i = A == null ? void 0 : A.current) == null || i.style.setProperty(
          "--av-text-area-label",
          `${L}px`
        )), w && (U.current = w, ($ = R == null ? void 0 : R.current) == null || $.style.setProperty(
          "--av-text-area-helper-text",
          `${w}px`
        )), O.current = ce || O.current;
      }
    }, [h, o]), /* @__PURE__ */ se("div", { className: b.wrapper, children: [
      /* @__PURE__ */ g(
        "label",
        {
          htmlFor: k,
          id: x,
          className: b.accessibleLabel,
          children: t
        }
      ),
      /* @__PURE__ */ g(
        "textarea",
        {
          ref: K,
          id: k,
          name: r,
          disabled: T,
          placeholder: o ? void 0 : " ",
          className: b.textArea,
          rows: 1,
          ...d && { "aria-describedby": `${k}-helper` },
          ...n && { "aria-invalid": "true" },
          ...S && !o && { style: { paddingRight: Y } },
          value: h,
          onChange: ne,
          onFocus: oe,
          onBlur: ae,
          ...B
        }
      ),
      !o && /* @__PURE__ */ g(
        "label",
        {
          ref: A,
          "aria-hidden": !0,
          htmlFor: k,
          className: b.visibleLabel,
          children: t
        }
      ),
      ee && /* @__PURE__ */ g(
        "div",
        {
          ref: R,
          id: `${k}-helper`,
          className: b.helperText,
          children: d
        }
      ),
      S && /* @__PURE__ */ g(
        "div",
        {
          ref: Q,
          className: b.rightElement,
          children: S
        }
      ),
      n && d && /* @__PURE__ */ g(_e, { politeness: "polite", clearAnnouncementDelay: 500, children: te })
    ] });
  }
);
we.displayName = "TextArea";
export {
  z as TEXT_AREA_CLASSNAME,
  pe as TEXT_AREA_CONTROL_RIGHT_CLASSNAME,
  H as TEXT_AREA_HELPER_TEXT_CLASSNAME,
  fe as TEXT_AREA_WRAPPER_CLASSNAME,
  we as TextArea
};
